using System;
using System.Data;

using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Admin_Ajax_CategoryExpansion : WebBlockPage
{
    private bool AlternatingRow = true;

    protected override void OnInit(EventArgs e)
    {
        Response.Cache.SetCacheability(HttpCacheability.NoCache);
        base.OnInit(e);
    }

    protected override void Render(HtmlTextWriter writer)
    {
        if (Request["CategoryID"] != null)
        {
            int CategoryID = Int32.Parse(Request["CategoryID"]);

            string expandUrl = Page.ClientScript.GetWebResourceUrl(typeof(System.Web.UI.WebControls.TreeView), "TreeView_Default_Expand.gif");
            string collapseUrl = Page.ClientScript.GetWebResourceUrl(typeof(System.Web.UI.WebControls.TreeView), "TreeView_Default_Collapse.gif");

            DataTable dt = Database.Categories_GetChildren(CategoryID);
            DataTable Products = Database.Selectors_GetByCategoryID(CategoryID);

            writer.Write("<table class=\"categorydatabase\">");

            if (dt.Rows.Count == 0)
            {
                writer.Write("<tr><td class='sortDiv'><b>0 Categories:</b> <a href=\"EditCategory.aspx?ParentCategoryID=");
                writer.Write(CategoryID.ToString());
                writer.Write("\">Add New Category</a></td></tr>");
            }
            else
            {
                writer.Write("<tr><td class='sortDiv'><b>");
                writer.Write(dt.Rows.Count.ToString());
                writer.Write(" Sub-Categories:</b> <a href=\"javascript:LoadSubWindow('SortCategory.aspx?CategoryID=");
                writer.Write(CategoryID.ToString());
                writer.Write("&redirect=true');\">Sort</a> | <a href=\"EditCategory.aspx?ParentCategoryID=");
                writer.Write(CategoryID.ToString());
                writer.Write("\">Add New Category</a></td></tr>");

                foreach (DataRow dr in dt.Rows)
                {
                    AlternatingRow = !AlternatingRow;
                    writer.Write("<tr");
                    if (AlternatingRow)
                        writer.Write(" class=\"alternatingrow\"");
                    writer.Write(">");

                    writer.Write("<td class=\"categoryname\" expanded=\"false\">");
                    writer.Write("<a href=\"javascript:void(0);\" onClick=\"toggleCategory(this.parentNode,");
                    writer.Write(dr["CategoryID"].ToString());
                    writer.Write("); return false;\"><img src=\"");
                    writer.Write(expandUrl);
                    writer.Write("\" border=\"0\" align=\"absmiddle\" /></a>");

                    writer.Write("<a href=\"");
                    writer.Write("EditCategory.aspx?CategoryID=");
                    writer.Write(dr["CategoryID"].ToString());
                    writer.Write("\">");
                    writer.Write((String)dr["CategoryName"]);
                    writer.Write("</a>");
                    writer.Write("</td></tr>");
                }
            }

            if (Products.Rows.Count == 0)
            {
                writer.Write("<tr><td class='sortDiv'><b>0 Product Pages:</b> <a href=\"EditSelector_Basics.aspx?CategoryID=" + CategoryID.ToString() + "\">Add New Product Page</a></td></tr>");
            }
            else
            {
                writer.Write("<tr><td class='sortDiv'><b>");
                writer.Write(Products.Rows.Count.ToString());
                writer.Write(" Product Pages:</b> <a href=\"javascript:LoadSubWindow('SortProducts.aspx?CategoryID=");
                writer.Write(CategoryID.ToString());
                writer.Write("&redirect=true');\">Sort</a> | <a href=\"EditSelector_Basics.aspx?CategoryID=");
                writer.Write(CategoryID.ToString());
                writer.Write("\">Add New Product Page</a></td></tr>");

                foreach (DataRow dr in Products.Rows)
                {
                    AlternatingRow = !AlternatingRow;
                    writer.Write("<tr");
                    if (AlternatingRow)
                        writer.Write(" class=\"alternatingrow\"");
                    writer.Write(">");
                    writer.Write("<td class=\"productname\">");

                    writer.Write("<a href=\"EditSelector_Basics.aspx?SelectorID=");
                    writer.Write(dr["SelectorID"].ToString());
                    writer.Write("\">");

                    if (dr["SKU"] != DBNull.Value && ((string)dr["SKU"]).Length > 0)
                    {
                        writer.Write("<span style='color: red; font-weight: bold;'>(");
                        writer.Write((string)dr["SKU"]);
                        writer.Write(")</span> ");
                    }

                    writer.Write((string)dr["Name"]);
                    writer.Write("</a>");

                    writer.Write("</td></tr>");
                }
            }

            writer.Write("</table>");
        }
    }
}
