<%@ Control Language="C#" AutoEventWireup="true" CodeFile="Items.ascx.cs" Inherits="Admin_Controls_Items" %>
<%@ Register TagPrefix="Controls" TagName="EditItem" Src="~/Admin/Controls/EditItem.ascx" %>


<asp:Menu
    id="Menu1"
    Orientation="Horizontal"
    StaticMenuItemStyle-CssClass="tab"
    StaticSelectedStyle-CssClass="selectedTab"
    CssClass="tabs"
    OnMenuItemClick="Menu1_MenuItemClick"
    Runat="server">
    <Items>
    <asp:MenuItem Text="Item List" Value="0" Selected="true" />
    <asp:MenuItem Text="Add New Item" Value="1" />
    <asp:MenuItem Text="Reuse an Item" Value="2" />
    </Items>    
</asp:Menu>

<div class="tabContents">
    <asp:MultiView ID="mvContent" runat="Server" ActiveViewIndex="0">
        <asp:View ID="vwBasic" runat="server">
            <table>
                <tr>
                    <td>
                        <asp:GridView ID="gvItems" runat="server" GridLines="None" DataKeyNames="ItemID" AutoGenerateColumns="false" CellSpacing="5" OnRowDataBound="gvItems_RowDataBound" EmptyDataText="There are no items currently associated with this product page.  Use the tabs at the top to add existing or new items.">
                            <HeaderStyle Font-Size="Small" Font-Bold="false" />
                            <Columns>
                                <asp:TemplateField ItemStyle-Width="40px">
                                    <ItemTemplate>
                                        <asp:CheckBox ID="cbSelect" runat="server" />
                                    </ItemTemplate>
                                </asp:TemplateField>
                                <asp:BoundField DataField="SKU" HeaderText="SKU" ItemStyle-Width="60px" />
                                <asp:HyperLinkField DataNavigateUrlFormatString="../EditSelector_MemberItems.aspx?SelectorID={0}&ItemID={1}" DataNavigateUrlFields="SelectorID,ItemID" DataTextField="Name" HeaderText="Name" ItemStyle-Width="400px" />
                                <asp:TemplateField HeaderText="Price" ItemStyle-Width="60px">
                                    <ItemTemplate>
                                        <asp:Literal ID="litPrice" runat="server" />
                                    </ItemTemplate>
                                </asp:TemplateField>
                                <asp:BoundField DataField="Inventory" HeaderText="Inventory" />
                            </Columns>
                        </asp:GridView>
                        
                        <% if (gvItems.Rows.Count > 0) { %>
                        <asp:Button ID="btnRemoveSelected" runat="server" Text="Remove Selected" OnClick="btnRemoveSelected_Click" />
                        <% } %>
                    </td>
                </tr>
            </table>
        </asp:View>
        <asp:View ID="vwAddItem" runat="server">
            <Controls:EditItem ID="EditItem1" Runat="server" />
        </asp:View>
        <asp:View ID="vwReuseItem" runat="server">
            This tool enables you to reuse an item from another product page.
            <table>
                <tr>
                    <td>Category:</td>
                    <td><asp:DropDownList ID="ddlCategory" runat="server" DataTextField="CanonicalName" DataValueField="CategoryID" AutoPostBack="True" OnSelectedIndexChanged="ddlCategory_SelectedIndexChanged" Width="500px" /></td>
                </tr>
                <tr>
                    <td>Product Page:</td>
                    <td><asp:DropDownList ID="ddlSelector" runat="server" DataTextField="Name" DataValueField="SelectorID" AutoPostBack="True" Enabled="false" OnSelectedIndexChanged="ddlSelector_SelectedIndexChanged" Width="500px" /></td>
                </tr>
                <tr>
                    <td>Item:</td>
                    <td><asp:DropDownList ID="ddlItem" runat="server" DataTextField="Name" DataValueField="ItemID" Enabled="false" Width="500px" /></td>
                </tr>
                <tr>
                    <td></td>
                    <td><asp:Button ID="btnCopy" runat="server" Text="Copy Item Details" OnClick="btnCopy_Click" /></td>
                </tr>
            </table>
        </asp:View>
    </asp:MultiView>
</div>