using System;
using System.Data;

using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text;
using System.Collections.Generic;

public partial class Admin_Controls_Related : WebBlockUserControl
{
    public int SelectorID
    {
        get { return (ViewState["SelectorID"] == null ? 0 : (int)ViewState["SelectorID"]); }
        set { ViewState["SelectorID"] = value; }
    }

    #region Member Items Functions
    private void BindSelectorItems()
    {
        DataTable dt = Database.RelatedSelectors_GetBySelectorID(SelectorID);
        gvItems.DataSource = dt;
        gvItems.DataBind();
    }

    protected void gvItems_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        switch (e.CommandName)
        {
            case "del":
                Database.RelatedSelectors_Delete(SelectorID, Int32.Parse((string)e.CommandArgument));
                BindData();
                break;
            default:
                break;
        }
    }
    #endregion

    #region Item Database Functions
    private void BindImportItems(bool FullSearch)
    {
        DataTable dt;

        if (FullSearch)
        {
            string srchSKU = "%";
            if (txtSearchSKU.Text.Length > 0)
                srchSKU += txtSearchSKU.Text + "%";

            string srchName = "%";
            if (txtSearchName.Text.Length > 0)
                srchName += txtSearchName.Text + "%";

            dt = Database.Selectors_Search(srchSKU, srchName);
        }
        else
        {
            dt = Database.Selectors_GetAll();
        }

        gvItemDatabase.DataSource = dt;
        gvItemDatabase.DataBind();
    }
    protected void btnSearch_Click(object sender, EventArgs e)
    {
        if (txtSearchName.Text.Length == 0 &&
            txtSearchSKU.Text.Length == 0)
        {
            BindImportItems(false);
        }
        else
        {
            BindImportItems(true);
        }
    }
    protected void btnAdd_Click(object sender, EventArgs e)
    {
        foreach (GridViewRow gvr in gvItemDatabase.Rows)
        {
            if (gvr.RowType == DataControlRowType.DataRow)
            {
                CheckBox cb = (CheckBox)gvr.Cells[0].Controls[1];
                if (cb.Checked)
                {
                    int RelatedSelectorID = (int)gvItemDatabase.DataKeys[gvr.RowIndex].Value;

                    DataRow dr = Database.RelatedSelectors_Get(SelectorID, RelatedSelectorID);

                    if (dr == null)
                        Database.RelatedSelectors_Add(SelectorID, RelatedSelectorID);
                }
            }
        }

        BindSelectorItems();

        Menu1.Items[0].Selected = true;
        mvContent.ActiveViewIndex = 0;
    }
    protected void btnRemoveSelected_Click(object sender, EventArgs e)
    {
        foreach (GridViewRow gvr in gvItems.Rows)
        {
            if (gvr.RowType == DataControlRowType.DataRow)
            {
                CheckBox cb = (CheckBox)gvr.Cells[0].Controls[1];
                if (cb.Checked)
                {
                    int RelatedSelectorID = (int)gvItems.DataKeys[gvr.RowIndex].Value;

                    Database.RelatedSelectors_Delete(SelectorID, RelatedSelectorID);
                }
            }
        }

        BindSelectorItems();
    }
    #endregion

    #region Page-Wide functions
    public void BindData()
    {
        BindSelectorItems();
    }

    protected void Menu1_MenuItemClick(object sender, MenuEventArgs e)
    {
        mvContent.ActiveViewIndex = Int32.Parse(e.Item.Value);

        if (mvContent.ActiveViewIndex == 0)
            BindSelectorItems();
        else if (mvContent.ActiveViewIndex == 1)
            BindImportItems(false);
    }
    #endregion
}
