using System;
using System.Data;

using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Net.Mail;
using System.Text;

public partial class Admin_EditOrder : WebBlocks.AdministrativePage
{
    private int _OrderID = 0;
    public int OrderID
    {
        get
        {
            try
            {
                if (_OrderID == 0)
                    _OrderID = Int32.Parse(Request["OrderID"]);
            }
            catch { }

            return _OrderID;
        }
        set { _OrderID = value; }
    }

    private int OrderBillingAddressID
    {
        get { return (ViewState["OrderBillingAddressID"] == null ? 0 : (int)ViewState["OrderBillingAddressID"]); }
        set { ViewState["OrderBillingAddressID"] = value; }
    }

    private int OrderShippingAddressID
    {
        get { return (ViewState["OrderShippingAddressID"] == null ? 0 : (int)ViewState["OrderShippingAddressID"]); }
        set { ViewState["OrderShippingAddressID"] = value; }
    }


    protected override void OnInit(EventArgs e)
    {
        OrderContents1.OrderID = OrderID;
        OrderStatus1.OrderID = OrderID;
        base.OnInit(e);
    }

    private string CheckNulls(object val)
    {
        if (val is DBNull)
            return "";
        else
            return val.ToString();
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            BindData();
        }
    }

    private void BindData()
    {
        OrderContents1.BindData();

        // populate tables
        Utilities.PopulateStateList(ddlBillState);
        Utilities.PopulateCountryList(ddlBillCountry);
        Utilities.PopulateStateList(ddlShipState);
        Utilities.PopulateCountryList(ddlShipCountry);

        DataRow OrderInfo = Database.Orders_GetByOrderID(OrderID);

        litTimestamp.Text = CheckNulls(OrderInfo["TimeStamp"]);
        litIsAuthorized.Text = ((bool)OrderInfo["IsAuthorized"] ? "Yes" : "No");
        litIsCaptured.Text = ((bool)OrderInfo["IsCaptured"] ? "Yes" : "No");
        litIPAddress.Text = CheckNulls(OrderInfo["IPAddress"]);
        litPaymentRefCode.Text = CheckNulls(OrderInfo["PaymentRefCode"]);
        litResponseCode.Text = CheckNulls(OrderInfo["LastResponseCode"]);
        litResponseText.Text = CheckNulls(OrderInfo["LastResponseText"]);
        litCardType.Text = CheckNulls(OrderInfo["CardType"]);
        litLastFour.Text = CheckNulls(OrderInfo["LastFour"]);
        txtInternalComments.Text = (OrderInfo["AdminComments"] == DBNull.Value || ((string)OrderInfo["AdminComments"]).Length == 0 ? "None" : (string)OrderInfo["AdminComments"]);
        litPaymentMethod.Text = CheckNulls(OrderInfo["PaymentMethod"]);
        litPONumber.Text = CheckNulls(OrderInfo["PONumber"]);
        txtGiftMessage.Text = CheckNulls(OrderInfo["UserComments"]);

        OrderBillingAddressID = (int)OrderInfo["BillingAddressID"];
        OrderShippingAddressID = (int)OrderInfo["ShippingAddressID"];

        DataRow BillingAddress = Database.OrderAddresses_GetByOrderAddressID((int)OrderInfo["BillingAddressID"]);

        txtBillFirstName.Text = CheckNulls(BillingAddress["FirstName"]);
        txtBillLastName.Text = CheckNulls(BillingAddress["LastName"]);
        txtBillAddress.Text = CheckNulls(BillingAddress["Address"]);
        txtBillCity.Text = CheckNulls(BillingAddress["City"]);
        ddlBillState.SelectedValue = CheckNulls(BillingAddress["State"]);
        ddlBillCountry.SelectedValue = CheckNulls(BillingAddress["Country"]);
        txtBillZipCode.Text = CheckNulls(BillingAddress["ZipCode"]);
        txtBillPhone.Text = CheckNulls(BillingAddress["Phone"]);

        DataRow ShippingAddress = Database.OrderAddresses_GetByOrderAddressID((int)OrderInfo["ShippingAddressID"]);

        txtShipFirstName.Text = CheckNulls(ShippingAddress["FirstName"]);
        txtShipLastName.Text = CheckNulls(ShippingAddress["LastName"]);
        txtShipAddress.Text = CheckNulls(ShippingAddress["Address"]);
        txtShipCity.Text = CheckNulls(ShippingAddress["City"]);
        ddlShipState.SelectedValue = CheckNulls(ShippingAddress["State"]);
        ddlShipCountry.SelectedValue = CheckNulls(ShippingAddress["Country"]);
        txtShipZipCode.Text = CheckNulls(ShippingAddress["ZipCode"]);

        txtEmailAddress.Text = CheckNulls(ShippingAddress["EmailAddress"]);
        hypEmail.NavigateUrl = "mailto:" + CheckNulls(ShippingAddress["EmailAddress"]);
    }

    protected void btnUpdate_Click1(object sender, EventArgs e)
    {
        Page.Validate();
        if (Page.IsValid)
        {
            Database.OrderAddresses_Update(OrderBillingAddressID,
                                            txtBillFirstName.Text,
                                            txtBillLastName.Text,
                                            txtBillAddress.Text,
                                            txtBillCity.Text,
                                            ddlBillState.SelectedValue,
                                            ddlBillCountry.SelectedValue,
                                            txtBillZipCode.Text,
                                            txtBillPhone.Text,
                                            "");

            Database.OrderAddresses_Update(OrderShippingAddressID,
                                            txtShipFirstName.Text,
                                            txtShipLastName.Text,
                                            txtShipAddress.Text,
                                            txtShipCity.Text,
                                            ddlShipState.SelectedValue,
                                            ddlShipCountry.SelectedValue,
                                            txtShipZipCode.Text,
                                            "",
                                            txtEmailAddress.Text);

            Database.Orders_SetAdminComment(OrderID, txtInternalComments.Text);

            hypEmail.NavigateUrl = "mailto:" + txtEmailAddress.Text;
        }
    }
}
