using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;


public partial class Admin_EditSelector_Basics : WebBlocks.AdministrativePage
{
    public int SelectorID
    {
        get { return (ViewState["SelectorID"] == null ? 0 : (int)ViewState["SelectorID"]); }
        set { ViewState["SelectorID"] = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            if (Request["SelectorID"] != null)
                SelectorID = Int32.Parse(Request["SelectorID"]);

            BindData();
        }
    }

    private void BindData()
    {
        if (SelectorID > 0)
        {
            DataRow dr = Database.Selectors_GetBySelectorID(SelectorID);

            txtSKU.Text = (dr["SKU"] != DBNull.Value ? (string)dr["SKU"] : "");
            txtName.Text = (string)dr["Name"];
            txtPrice.Text = (string)dr["TextPrice"];
            txtDescription.Value = (string)dr["Description"];
            ddlSelectorType.SelectedValue = (string)dr["SelectorType"];
            chkActive.Checked = (bool)dr["Active"];
            chkBrowsable.Checked = (bool)dr["Browsable"];
        }
    }

    protected void btnSave_Click(object sender, EventArgs e)
    {
        if (SelectorID == 0)
        {
            SelectorID = Database.Selectors_Add(ddlSelectorType.SelectedValue,
                                                txtSKU.Text,
                                                txtName.Text,
                                                txtDescription.Value,
                                                txtPrice.Text,
                                                chkActive.Checked,
                                                chkBrowsable.Checked);

            // this takes care of adding the selector to a provided category
            if (Request["CategoryID"] != null)
            {
                int CategoryID = Int32.Parse(Request["CategoryID"]);
                Database.CategorySelectorMap_Add(SelectorID, CategoryID);
            }

            // and now start the wizard
            Response.Redirect("EditSelector_MemberItems.aspx?Wizard=1&SelectorID=" + SelectorID);
        }
        else
        {
            Database.Selectors_Update(SelectorID,
                                    ddlSelectorType.SelectedValue,
                                    txtSKU.Text,
                                    txtName.Text,
                                    txtDescription.Value,
                                    txtPrice.Text,
                                    chkActive.Checked,
                                    chkBrowsable.Checked);
        }

        pnlSaved.Visible = true;
    }

    protected void btnDelete_Click(object sender, EventArgs e)
    {
        // manually delete the photo files

        DataTable dt = Database.PhotoSets_GetBySelectorID(SelectorID);

        foreach (DataRow dr in dt.Rows)
            Utilities.DeleteProductPhoto((string)dr["Filename"]);

        Database.Selectors_Delete(SelectorID);

        Response.Redirect("StorePages.aspx");
    }
}
