<%@ Page Language="C#" MasterPageFile="~/Admin/Admin.master" AutoEventWireup="true" CodeFile="EditSelector_Photos.aspx.cs" Inherits="Admin_EditSelector_Photos" Title="Edit Product Page - Photos" ValidateRequest="false" %>
<%@ Register TagPrefix="AdminControls" Namespace="AdminControls" Assembly="__code" %>
<%@ Register TagPrefix="Custom2" Namespace="Admin" Assembly="__code" %>

<asp:Content ContentPlaceHolderID="Breadcrumbs" runat="server">
    <div class="panel breadcrumb">
        Home &gt; <a href="StorePages.aspx?SelectorID=<%= SelectorID %>">Store Pages</a> &gt; Add/Edit Product Page &gt; Photos
    </div>
</asp:Content>

<asp:Content ID="Content1" ContentPlaceHolderID="LeftNavBar" Runat="Server">
    <div class="panel">
        <table class="sidePanel" cellpadding="1" cellspacing="0">
        <tr>
            <th>
                <a href="StorePages.aspx?SelectorID=<%= SelectorID %>">&lt; Back to Store Pages</a>
            </th>
        </tr>
        </table>
    </div>
    <div class="panel">
        <table class="sidePanel" cellpadding="1" cellspacing="0">
        <tr>
            <th>
                <a href="EditSelector_Basics.aspx?SelectorID=<%= SelectorID %>">Basic Information</a>
            </th>
        </tr>
        </table>
    </div>
    <div class="panel">
        <table class="sidePanel" cellpadding="1" cellspacing="0">
        <tr>
            <th>
                <a href="EditSelector_MemberItems.aspx?SelectorID=<%= SelectorID %>">Member Items</a>
            </th>
        </tr>
        </table>
    </div>
    <div class="panel">
        <table class="sidePanel" cellpadding="1" cellspacing="0">
        <tr>
            <th>
                <a href="EditSelector_Customizations.aspx?SelectorID=<%= SelectorID %>">Customizations</a>
            </th>
        </tr>
        </table>
    </div>
    <div class="panel">
        <table class="sidePanel" cellpadding="1" cellspacing="0">
        <tr>
            <th>
                <a href="EditSelector_Categories.aspx?SelectorID=<%= SelectorID %>">Categories</a>
            </th>
        </tr>
        </table>
    </div>
    <div class="panel">
        <table class="sidePanel" cellpadding="1" cellspacing="0">
        <tr>
            <th>
                <a href="EditSelector_Related.aspx?SelectorID=<%= SelectorID %>">Related Products</a>
            </th>
        </tr>
        </table>
    </div>
    <div class="panel_selected">
        <table class="sidePanel" cellpadding="1" cellspacing="0">
        <tr>
            <th>
                <a href="EditSelector_Photos.aspx?SelectorID=<%= SelectorID %>">Photos</a>
            </th>
        </tr>
        </table>
    </div>
    <div class="panel">
        <table class="sidePanel" cellpadding="1" cellspacing="0">
        <tr>
            <th>
                <a href="EditSelector_ProductAttributes.aspx?SelectorID=<%= SelectorID %>">Product Attributes</a>
            </th>
        </tr>
        </table>
    </div>
    <div class="panel">
        <table class="sidePanel" cellpadding="1" cellspacing="0">
        <tr>
            <th>
                <a href="Preview.aspx?SelectorID=<%= SelectorID %>" target="_blank">View This Product Page</a>
            </th>
        </tr>
        </table>
    </div>
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="Content" Runat="Server">    
    <h1>Photos</h1>
    
    <div style="width: 690px">
    
        <table>
            <tr valign="top">
                <td style="width: 350px">
                    <asp:Image ID="imgPrimary" runat="Server" ImageUrl="../ProductPhotos/Medium/noPhoto.gif" />
                </td>
                <td>
                    <table>
                        <tr valign="top">
                            <td colspan="2">
                                Photo ID: <b><asp:Literal ID="litPhotoSetID" runat="Server" Text="New Photo" /></b>
                            </td>
                        </tr>
                        <tr valign="top">
                            <td colspan="2">
                                Image File:
                            </td>
                        </tr>
                        <tr valign="top">
                            <td colspan="2">
                                <AdminControls:FileUploadControl ID="FileSingle" runat="server" Directory="~/ProductPhotos/" AutoUpload="false" />
                                <asp:CustomValidator runat="server" ID="custFileSingle" Display="Dynamic" ErrorMessage="Please select a file to upload." ValidationGroup="Upload" OnServerValidate="custFileSingle_ServerValidate" />
                            </td>
                        </tr>
                        <tr>
                            <td colspan="2">
                                Caption (optional):
                            </td>
                        </tr>
                        <tr valign="top">
                            <td colspan="2">
                                <asp:TextBox ID="txtCaption" TextMode="MultiLine" Width="220px" Height="100px" runat="server" MaxLength="1000" />
                            </td>
                        </tr>
                        <tr>
                            <td align="center" colspan="2">
                                <div align="left">
                                    <asp:ValidationSummary DisplayMode="BulletList" ID="valDetails" runat="server" ValidationGroup="Upload" />
                                </div>
                                <asp:Button ID="btnSubmit" runat="server" Text="Upload" OnClick="btnSubmit_Click" ValidationGroup="Upload" />
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>
        <br />
        <br />
        <asp:DataList ID="dlPhotos" runat="server" RepeatDirection="Horizontal" RepeatColumns="5" DataKeyField="PhotoSetID" OnItemCommand="dlPhotos_ItemCommand">
            <ItemStyle Width="130px" HorizontalAlign="Center" />
            <ItemTemplate>
                <asp:LinkButton ID="lnkEdit" runat="server" CommandName="ed"><img src="../LiveImage.ashx?preset=small&img=ProductPhotos/<%# Eval("Filename") %>" /></asp:LinkButton>
                <br />
                <WebBlocks:RepeaterRadioButton ID="rbSelect" GroupName="rblPhotos" runat="Server" />
            </ItemTemplate>
        </asp:DataList>
        <br />
        <br />
        <asp:Button ID="btnDelete" runat="server" Text="Delete" OnClick="btnDelete_Click" />
        <asp:Button ID="btnSetPrimary" runat="Server" Text="Set Primary" OnClick="btnSetPrimary_Click" />
    </div>
    
    
    
</asp:Content>

<asp:Content ID="Content3" ContentPlaceHolderID="AdditionalPanels" Runat="Server">
    <asp:Panel CssClass="panel right saved" runat="server" ID="pnlSaved" Visible="False" EnableViewState="false">
        Saved
    </asp:Panel>
    <div class="panel right">
        <asp:Button ID="btnSave" runat="server" Text="Save" OnClick="btnSave_Click" ValidationGroup="Basic" />
    </div>
</asp:Content>

