using System;
using System.Data;

using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Admin_OrderReceipt : WebBlocks.AdministrativePage
{
    private AddressStruct _ShippingAddress;
    public AddressStruct ShippingAddress
    {
        get { return _ShippingAddress; }
        set { _ShippingAddress = value; }
    }

    private AddressStruct _BillingAddress;
    public AddressStruct BillingAddress
    {
        get { return _BillingAddress; }
        set { _BillingAddress = value; }
    }

    public int OrderID;
    public string TrackingNumber = "None";
    public string OrderDate = null;
    public string DateShipped = "Not yet shipped";

    protected override void OnInit(EventArgs e)
    {
        OrderID = Int32.Parse(Request["OrderID"]);
        OrderContents1.OrderID = OrderID;
        base.OnInit(e);
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            OrderContents1.BindData();
            BindData();
        }
    }

    private void BindData()
    {
        DataRow dr = Database.Orders_GetByOrderID(OrderID);

        int BillingAddressID = (int)dr["BillingAddressID"];
        int ShippingAddressID = (int)dr["ShippingAddressID"];

        DataRow Billing = Database.OrderAddresses_GetByOrderAddressID(BillingAddressID);
        DataRow Shipping = Database.OrderAddresses_GetByOrderAddressID(ShippingAddressID);

        _ShippingAddress.FirstName = (string)Shipping["FirstName"];
        _ShippingAddress.LastName = (string)Shipping["LastName"];
        _ShippingAddress.Address = (string)Shipping["Address"];
        _ShippingAddress.City = (string)Shipping["City"];
        _ShippingAddress.State = (string)Shipping["State"];
        _ShippingAddress.Country = (string)Shipping["Country"];
        _ShippingAddress.ZipCode = (string)Shipping["ZipCode"];
        _ShippingAddress.EmailAddress = (string)Shipping["EmailAddress"];

        _BillingAddress.FirstName = (string)Billing["FirstName"];
        _BillingAddress.LastName = (string)Billing["LastName"];
        _BillingAddress.Address = (string)Billing["Address"];
        _BillingAddress.City = (string)Billing["City"];
        _BillingAddress.State = (string)Billing["State"];
        _BillingAddress.Country = (string)Billing["Country"];
        _BillingAddress.ZipCode = (string)Billing["ZipCode"];
        _BillingAddress.Phone = (string)Billing["Phone"];

        if (dr["TrackingNumber"] != DBNull.Value)
            TrackingNumber = (string)dr["TrackingNumber"];

        OrderDate = ((DateTime)dr["TimeStamp"]).ToShortDateString();
        if (dr["DateShipped"] != DBNull.Value)
            DateShipped = ((DateTime)dr["DateShipped"]).ToShortDateString();

    }
}
