<%@ WebHandler Language="C#" Class="Search" %>

using System;
using System.Web;
using System.Data;


public class Search : IHttpHandler {
    
    public void ProcessRequest (HttpContext context)
    {
        context.Response.ContentType = "text/xml";
        
        DatabaseClass Database = new DatabaseClass(System.Configuration.ConfigurationManager.AppSettings["connectionString"]);

        string query = context.Request["query"];
        if (query != null)
        {
            context.Response.Write("<results>");
            string skuQuery = query;
            query = "%" + query + "%";

            /* CATEGORIES */

            DataTable dt = Database.Categories_Search(query);

            if (dt.Rows.Count > 0)
            {
                context.Response.Write("<categories>");
                
                for(int i = 0; i < 5; i++) // only show top 5
                {
                    DataRow dr = dt.Rows[i];
                    context.Response.Write("<category><name>");
                    context.Response.Write((string)dr["CategoryName"]);
                    context.Response.Write("</name><categoryid>");
                    context.Response.Write(dr["CategoryID"].ToString());
                    context.Response.Write("</categoryid></category>");
                }
                context.Response.Write("</categories>");
            }

            /* PRODUCTS */

            dt = Database.Selectors_SearchInclusive(10, skuQuery, query);

            if (dt.Rows.Count > 0)
            {
                context.Response.Write("<products>");
                foreach (DataRow dr in dt.Rows)
                {
                    context.Response.Write("<product><name>");
                    context.Response.Write((string)dr["Name"]);
                    context.Response.Write("</name><csmID>");
                    context.Response.Write(dr["CategorySelectorMapID"].ToString());
                    context.Response.Write("</csmID><thumbnail>");
                    if (dr["Photo"] != DBNull.Value)
                        context.Response.Write((string)dr["Photo"]);
                    else
                        context.Response.Write("noPhoto.gif");
                    context.Response.Write("</thumbnail></product>");
                }
                context.Response.Write("</products>");
            }

            context.Response.Write("</results>");
        }

        Database.Dispose();
    }
 
    public bool IsReusable {
        get {
            return false;
        }
    }

}