using System;
using System.Data;

using System.Configuration;
using System.Web;
using System.Collections.Specialized;
using System.Collections;

public static class Configuration
{
    public static StringDictionary ConfigDictionary;

    public static string Get(string variable)
    {
        return ConfigDictionary[variable];
    }

    public static void Set(string variable, string value)
    {
        ConfigDictionary[variable] = value;
    }

    public static void LoadFromDatabase()
    {
        DatabaseClass Database = new DatabaseClass(System.Configuration.ConfigurationManager.AppSettings["connectionString"]);

        if (ConfigDictionary == null)
            ConfigDictionary = new StringDictionary();


        DataTable dt = Database.Variables_GetAll();

        foreach(DataRow dr in dt.Rows)
        {
            object o = dr["Value"];
            ConfigDictionary[(string)dr["Variable"]] = (o != DBNull.Value ? (string)o : "");
        }

        Database.Dispose();
    }

    public static void CommitToDatabase()
    {
        DatabaseClass Database = new DatabaseClass(System.Configuration.ConfigurationManager.AppSettings["connectionString"]);

        foreach(DictionaryEntry de in ConfigDictionary)
            Database.Variables_Update((string)de.Key, (string)de.Value);

        Database.Dispose();
    }
}
