using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text;

namespace ConfigurationControls
{
    public class ConfigCheckboxList : CheckBoxList, IConfigurationControl
    {
        private string _Variable = "";
        public string Variable
        {
            get { return _Variable; }
            set { _Variable = value; }
        }

        private bool _Required = false;
        public bool Required
        {
            get { return _Required; }
            set { _Required = value; }
        }

        public string FieldValue
        {
            get
            {
                StringBuilder sb = new StringBuilder();
                foreach (ListItem li in Items)
                    if (li.Selected)
                    {
                        sb.Append(li.Value);
                        sb.Append(",");
                    }
                return sb.ToString().TrimEnd(',');
            }
            set
            {
                foreach (string s in value.Split(','))
                    foreach (ListItem li in Items)
                        if (li.Value == s)
                            li.Selected = true;
            }
        }
    }
}