using System;
using System.Data;

using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

namespace Estore
{
    public class BreadCrumbs : WebBlockUserControl
    {
        private int _BaseCategoryID = 0;
        public int BaseCategoryID
        {
            get { return _BaseCategoryID; }
            set { _BaseCategoryID = value; }
        }

        private int _SelectedCategoryID = 0;
        public int SelectedCategoryID
        {
            get { return _SelectedCategoryID; }
            set { _SelectedCategoryID = value; }
        }

        private bool _IncludeBase = false;
        public bool IncludeBase
        {
            get { return _IncludeBase; }
            set { _IncludeBase = value; }
        }

        protected override void Render(HtmlTextWriter writer)
        {
            DataTable dt = Database.Categories_GetBreadcrumbTrail(_SelectedCategoryID, _BaseCategoryID, _IncludeBase);

            if (BaseCategoryID == 0 && _IncludeBase)
            {
                writer.Write("<a href=\"");
                writer.Write(Utilities.FormatCategoryUrl(0, "Products"));
                writer.Write("\">");
                writer.Write("Products");
                writer.Write("</a>");

                if (dt.Rows.Count > 0)
                    writer.Write(" &gt; ");
            }

            for(int i = dt.Rows.Count-1; i >= 0; i--)
            {
                writer.Write("<a href=\"");
                writer.Write(Utilities.FormatCategoryUrl((int)dt.Rows[i]["CategoryID"], (string)dt.Rows[i]["CategoryName"]));
                writer.Write("\">");
                writer.Write((string)dt.Rows[i]["CategoryName"]);
                writer.Write("</a>");

                if (i > 0)
                    writer.Write(" &gt; ");
            }

        }
    }
}
