using System;
using System.Net;
using System.IO;
using System.Data;


namespace Gateways
{
    public class NullGateway : GatewayBase
    {
        public NullGateway()
        {

        }

        public override GatewayResult InternalAuthorize(int OrderID, string FirstName, string LastName, string Address1, string Address2, string City, string State, string Zip, string Country, string Phone, string CustomerID, string CustomerIP, decimal Amount, string CardNumber, string ExpDate, string CSC)
        {
            GatewayResult result = new GatewayResult();
            result.Operation = GatewayOperation.Authorize;
            result.Successful = true;
            result.ResponseCode = "";
            result.ResponseText = "";
            result.PaymentReferenceCode = "------";
            return result;
        }

        public override GatewayResult InternalCapture(string PaymentReferenceCode, decimal Amount)
        {
            GatewayResult result = new GatewayResult();
            result.Operation = GatewayOperation.Authorize;
            result.Successful = true;
            result.ResponseCode = "";
            result.ResponseText = "";
            result.PaymentReferenceCode = "------";
            return result;
        }
        public override GatewayResult InternalVoid(string PaymentReferenceCode)
        {
            GatewayResult result = new GatewayResult();
            result.Operation = GatewayOperation.Authorize;
            result.Successful = true;
            result.ResponseCode = "";
            result.ResponseText = "";
            result.PaymentReferenceCode = "------";
            return result;
        }
        public override GatewayResult InternalCredit(string PaymentReferenceCode, string LastFour, decimal Amount)
        {
            GatewayResult result = new GatewayResult();
            result.Operation = GatewayOperation.Authorize;
            result.Successful = true;
            result.ResponseCode = "";
            result.ResponseText = "";
            result.PaymentReferenceCode = "------";
            return result;
        }
    }
}
