using System;
using System.Net;
using System.Data;
using System.Xml;
using System.Configuration;

using System.Collections.Generic;
using System.IO;

public class ShippingBase
{
	public ShippingBase()
    {
    }

    public virtual List<ShippingMethod> GetShippingMethods(string startzip, string endzip)
    {
        return new List<ShippingMethod>();
    }

    public static ShippingBase GetShippingObject(string name)
    {
        switch (name)
        {
            case "FlatRate":
                return new FlatRate();
            case "Fedex":
                return new Fedex();
            case "UPS":
                return new UPS();
            case "USPS":
                return new USPS();
            default:
                return new FlatRate();
        }
    }

    public XmlNode GetXmlResponse_Post(string url, string postData)
    {
        StreamWriter myWriter = null;
        HttpWebRequest objRequest = (HttpWebRequest)WebRequest.Create(url);
        objRequest.Method = "POST";
        objRequest.ContentLength = postData.Length;
        objRequest.ContentType = "application/x-www-form-urlencoded";
        myWriter = new StreamWriter(objRequest.GetRequestStream());
        myWriter.Write(postData);
        myWriter.Close();

        HttpWebResponse objResponse = (HttpWebResponse)objRequest.GetResponse();
        XmlDocument xmlDoc = new XmlDocument();
        xmlDoc.Load(objResponse.GetResponseStream());
        objResponse.Close();

        return xmlDoc;
    }
}
