using System;
using System.Data;

using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

namespace WebBlocks
{
    public class NewsAndEventsBlock : System.Web.UI.Control
    {
        private string _Category = null;
        public string Category
        {
            get { return _Category; }
            set { _Category = value; }
        }

        private string _CssClass = "";
        public string CssClass
        {
            get { return _CssClass; }
            set { _CssClass = value; }
        }

        private int _NumItems = 0;
        public int NumItems
        {
            get { return _NumItems; }
            set { _NumItems = value; }
        }

        protected override void Render(HtmlTextWriter writer)
        {
            DatabaseClass db = ((WebBlockPage)Page).Database;

            DataTable dt;

            if (_NumItems == 0)
                dt = db.NewsAndEvents_Get(_Category);
            else
                dt = db.NewsAndEvents_GetTop(_Category, _NumItems);


            // output the html
            writer.Write("<table cellpaddon='0' cellspacing='0' class=\"");
            writer.Write(_CssClass);
            writer.Write("\">");

            if (Page.Session["WebBlocksEditFlag"] != null)
            {
                writer.Write("<tr><td colspan='2'><a href=\"");
                writer.Write((Page.Request.ApplicationPath.Length == 1 ? "" : Page.Request.ApplicationPath));
                writer.Write("/Admin/EditEventContent.aspx\">Add New Event</a></td></tr>");
            }

            foreach (DataRow dr in dt.Rows)
            {
                string link = (Page.Request.ApplicationPath.Length == 1 ? "" : Page.Request.ApplicationPath) + "/ArticleDetails.aspx?articleID=" + dr["EventId"];

                writer.Write("<tr>");
                if (!dr.IsNull("Date"))
                    writer.Write("<td width='70'><b>" + Convert.ToDateTime(dr["Date"]).ToString("MM.dd.yy") + "</b></td>");
                writer.Write("<td><a href='" + link + "'>" + dr["Title"].ToString() + "</a>");
                if (Page.Session["WebBlocksEditFlag"] != null)
                    writer.Write(" <a href=\"" + (Page.Request.ApplicationPath.Length == 1 ? "" : Page.Request.ApplicationPath) + "/Admin/EditEventContent.aspx?EventId=" + dr["EventId"].ToString() + "\">[edit]</a>");
                writer.Write("</tr>");
            }
            writer.Write("<tr><td class='homeNewsBold' colspan='2'><a href='Articles.aspx'>Read all news</a></td></tr>");
            writer.Write("</table>");
        }
    }
}