<%@ Page Language="C#" MasterPageFile="~/Content.master" AutoEventWireup="true" CodeFile="ConfirmOrder.aspx.cs" Inherits="ConfirmOrder" Title="Checkout: Confirm Order" %>
<%@ Register TagPrefix="Controls" TagName="CartControl" Src="~/Controls/CartControl.ascx" %>
<%@ Register TagPrefix="Controls" TagName="CheckoutNavigation" Src="~/Controls/CheckoutNavigation.ascx" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentArea" Runat="Server">
<table class="fullContentArea" cellpadding="0" cellspacing="0">
    <tr>
        <td class="fullContentOpen">&nbsp;</td>
    </tr>
    <tr valign="top">
        <td class="fullContentSpan">
            <div class="pageHeader"><img src="images/page-hdr-checkout.gif" alt="Checkout" /></div>
            <table class="cartPage" align="center" cellpadding="0" cellspacing="0">
                <tr>
                    <td>
                        <Controls:CheckoutNavigation runat="Server" ID="CheckoutNav1" />
                        <br />
                        <div class="cartHeader">Your Cart</div>
                        <Controls:CartControl ID="CartControl1" runat="server" IsEditable="False" />
                        
                        
                        <br />
                        <div class="checkoutHeader">Purchase Information</div>
                        <table class="checkoutTwoColumn" cellpadding="0" cellspacing="0">
                            <tr valign="top">
                                <td class="column1">
                                    <div class="checkoutSubHeader">Billing Address&nbsp;&nbsp;<span class="checkoutChange"><a href="Checkout.aspx">Change</a></span></div>
                                    <table width="100%" class="checkoutForm" cellpadding="0" cellspacing="0">
                                        <tr>
                                            <td colspan="2"><WebBlocks:TextBlock ID="TextBlock1" BlockTitle="Order Confirmation - Billing Blurb" runat="server" /></td>
                                        </tr>
                                        <tr>
                                            <td>First Name:</td>
                                            <td><%= BillingAddress.FirstName %></td>
                                        </tr>
                                        <tr>
                                            <td>Last Name:</td>
                                            <td><%= BillingAddress.LastName %></td>
                                        </tr>
                                        <tr>
                                            <td>Address:</td>
                                            <td><%= BillingAddress.Address  %></td>
                                        </tr>
                                        <tr>
                                            <td>City:</td>
                                            <td><%= BillingAddress.City  %></td>
                                        </tr>
                                        <tr>
                                            <td>State:</td>
                                            <td><%= BillingAddress.State  %></td>
                                        </tr>
                                        <tr>
                                            <td>Country:</td>
                                            <td><%= BillingAddress.Country  %></td>
                                        </tr>
                                        <tr>
                                            <td>Zip Code:</td>
                                            <td><%= BillingAddress.ZipCode  %></td>
                                        </tr>
                                        <tr>
                                            <td>Phone:</td>
                                            <td><%= BillingAddress.Phone  %></td>
                                        </tr>        
                                    </table>
                                    
                                    <br />
                                    <br />
                                    
                                    <div class="checkoutSubHeader">Payment Information&nbsp;&nbsp;<span class="checkoutChange"><a href="Checkout.aspx">Change</a></span></div>
                                    <% if (PaymentInfo.PaymentType == "Credit Card") { %>
                                    <table width="100%" class="checkoutForm" cellpadding="0" cellspacing="0">
                                        <tr>
                                            <td colspan="2"><b><%= PaymentInfo.PaymentType %></b></td>
                                        <tr>
                                            <td>Card Type:</td>
                                            <td><%= PaymentInfo.CardType %></td>
                                        </tr>
                                        <tr>
                                            <td>Card Name:</td>
                                            <td><%= PaymentInfo.CardNumber %></td>
                                        </tr>
                                        <tr>
                                            <td>Expiration Date:</td>
                                            <td><%= PaymentInfo.ExpirationDate %></td>
                                        </tr>
                                        <tr>
                                            <td>Security Code:</td>
                                            <td>***</td>
                                        </tr>
                                    </table>
                                    <% } else if (PaymentInfo.PaymentType == "PO Number") { %>
                                    <table width="100%" class="checkoutForm" cellpadding="0" cellspacing="0">
                                        <tr>
                                            <td colspan="2"><b><%= PaymentInfo.PaymentType %></b></td>
                                        <tr>
                                            <td>PO Number:</td>
                                            <td><%= PaymentInfo.PONumber %></td>
                                        </tr>
                                    </table>
                                    <% } %>
                                </td>
                                <td class="column2">
                                    <div class="checkoutSubHeader">Shipping Address&nbsp;&nbsp;<span class="checkoutChange"><a href="PreCheckout.aspx">Change</a></span></div>
                                    <table width="100%" class="checkoutForm" cellpadding="0" cellspacing="0">
                                        <tr>
                                            <td>First Name:</td>
                                            <td><%= ShippingAddress.FirstName  %></td>
                                        </tr>
                                        <tr>
                                            <td>Last Name:</td>
                                            <td><%= ShippingAddress.LastName %></td>
                                        </tr>
                                        <tr>
                                            <td>Address:</td>
                                            <td><%= ShippingAddress.Address %></td>
                                        </tr>
                                        <tr>
                                            <td>City:</td>
                                            <td><%= ShippingAddress.City %></td>
                                        </tr>
                                        <tr>
                                            <td>State:</td>
                                            <td><%= ShippingAddress.State %></td>
                                        </tr>
                                        <tr>
                                            <td>Country:</td>
                                            <td><%= ShippingAddress.Country %></td>
                                        </tr>
                                        <tr>
                                            <td>Zip Code:</td>
                                            <td><%= ShippingAddress.ZipCode %></td>
                                        </tr>
                                        <tr>
                                            <td>Email Address:</td>
                                            <td><%= ShippingAddress.EmailAddress %></td>
                                        </tr>
                                    </table>
                                    <br />
                                    <br />
                                    <div class="checkoutSubHeader">Additional Ordering Info&nbsp;&nbsp;<span class="checkoutChange"><a href="Checkout.aspx">Change</a></span></div>
                                    <table width="100%" class="checkoutForm" cellpadding="0" cellspacing="0">
                                        <tr>
                                            <td width="175">Special Instructions/Comments:</td>
                                            <td>
                                                <%= OrderInfo.Comments %>
                                            </td>
                                        </tr>
                                    </table>
                                    <br />
                                    <br />
                                    <table width="100%" class="checkoutForm" cellpadding="0" cellspacing="0">
                                        <tr>
                                            <td><WebBlocks:TextBlock ID="TextBlock23" BlockTitle="Order Confirmation - Below Additional Ordering Info" runat="server" /></td>
                                        </tr>
                                    </table>
                                </td>
                            </tr>
                        </table>
                        
                        <div align="center">
                        <br />
                        <a href="PlaceOrder.aspx"><img src="images/placeorder.gif" alt="Place Order" /></a><br /><br />
                        <a href="javascript:window:print()"><img src="images/printpage.gif" alt="Print This Page" /></a><br /><br />
                        <img src="images/veri-sign.gif" alt="VeriSign" />
                        </div>
                        
                        
                    </td>
                </tr>
            </table>
        </td>
    </tr>
    <tr>
        <td class="fullContentClose">&nbsp;</td>
    </tr>
</table>
</asp:Content>

