using System;
using System.Data;

using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class ConfirmOrder : WebBlockPage
{
    public OrderInfo OrderInfo
    {
        get
        {
            if (Session["OrderInfo"] == null)
                Session["OrderInfo"] = new OrderInfo();
            return (OrderInfo)Session["OrderInfo"];
        }
    }

    private AddressStruct _ShippingAddress;
    public AddressStruct ShippingAddress
    {
        get { return _ShippingAddress; }
        set { _ShippingAddress = value; }
    }

    private AddressStruct _BillingAddress;
    public AddressStruct BillingAddress
    {
        get { return _BillingAddress; }
        set { _BillingAddress = value; }
    }

    private PaymentStruct _PaymentInfo;
    public PaymentStruct PaymentInfo
    {
        get { return _PaymentInfo; }
        set { _PaymentInfo = value; }
    }

    protected override void OnInit(EventArgs e)
    {
        if (ShoppingCart.GrandTotal == 0)
            Response.Redirect("Cart.aspx");

        SecurePage = true;
        base.OnInit(e);
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            BindData();
        }
    }

    private void BindData()
    {
        OrderInfo oi = OrderInfo;

        DataRow Billing = Database.Addresses_GetByAddressID(oi.BillingAddressID);
        DataRow Shipping = Database.Addresses_GetByAddressID(oi.ShippingAddressID);

        _ShippingAddress.FirstName = (string)Shipping["FirstName"];
        _ShippingAddress.LastName = (string)Shipping["LastName"];
        _ShippingAddress.Address = (string)Shipping["Address"];
        _ShippingAddress.City = (string)Shipping["City"];
        _ShippingAddress.State = (string)Shipping["State"];
        _ShippingAddress.Country = (string)Shipping["Country"];
        _ShippingAddress.ZipCode = (string)Shipping["ZipCode"];
        _ShippingAddress.EmailAddress = (string)Shipping["EmailAddress"];

        _BillingAddress.FirstName = (string)Billing["FirstName"];
        _BillingAddress.LastName = (string)Billing["LastName"];
        _BillingAddress.Address = (string)Billing["Address"];
        _BillingAddress.City = (string)Billing["City"];
        _BillingAddress.State = (string)Billing["State"];
        _BillingAddress.Country = (string)Billing["Country"];
        _BillingAddress.ZipCode = (string)Billing["ZipCode"];
        _BillingAddress.Phone = (string)Billing["Phone"];

        _PaymentInfo.PaymentType = oi.PaymentMethod;

        if (oi.PaymentMethod == "Credit Card")
        {
            _PaymentInfo.CardType = oi.CardName;
            _PaymentInfo.CardNumber = "************" + oi.CardNumber.Substring(oi.CardNumber.Length - 4);
            _PaymentInfo.ExpirationDate = oi.ExpMonth + "/" + oi.ExpYear;
        }
        else if (oi.PaymentMethod == "PO Number")
        {
            _PaymentInfo.PONumber = oi.PurchaseOrderNumber;
        }
    }
}
